<?php
/**
 * It will display the add/edit fields of the email template.
 * @author   Tyche Softwares
 * @package Abandoned-Cart-Pro-for-WooCommerce/Admin/Template
 * @since 5.0
 */
// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

if ( !class_exists('Wcap_Email_Template_Fields' ) ) {
    /**
     * It will display the add/edit fields of the email template.
     */
    class Wcap_Email_Template_Fields {
        /**
         * It will display the add/edit fields of the email template.
         * @globals mixed $wpdb
         * @globals mixed $woocommerce
         * @since 1.0 
         * @todo Remove inline Javascript.
         */
        public static function wcap_display_email_template_fields( ) {
            global $wpdb, $woocommerce;

            $mode = Wcap_Common::wcap_get_mode();

            if( 'edittemplate' == $mode ) {
                $edit_id = $_GET['id'];
                $query = "SELECT wpet . *  FROM `" . WCAP_NOTIFICATION_TEMPLATES_TABLE . "` AS wpet WHERE id= %d";
                $results = $wpdb->get_results( $wpdb->prepare( $query,  $edit_id ) );
            }
            if( 'copytemplate' == $mode ) {
                $copy_id        = $_GET['id'];
                $query_copy     = "SELECT wpet . *  FROM `" . WCAP_NOTIFICATION_TEMPLATES_TABLE . "` AS wpet WHERE id= %d";
                $results_copy   = $wpdb->get_results( $wpdb->prepare( $query_copy,$copy_id ) );
            }
            $active_post = ( empty( $_POST['is_active'] ) ) ? '0' : '1';
            ?>
            <?php if ( isset( $_POST['ac_settings_frm'] ) && $_POST['ac_settings_frm'] == 'save' ) { ?>
                <div id="message" class="updated fade">
                    <p>
                        <strong>
                            <?php _e( 'Your settings have been saved.', 'woocommerce-ac' ); ?>
                        </strong>
                    </p>
                </div>
                <?php } ?>
                <div id="content">
                    <form method="post" action="admin.php?page=woocommerce_ac_page&action=cart_recovery&section=emailtemplates" id="ac_settings">
                        <input type="hidden" name="mode" value="<?php echo $mode; ?>" />
                        <input type="hidden" name="id" value="<?php if( isset( $_GET['id'] ) ) echo $_GET['id']; ?>" />
                        <?php
                        $button_mode = "save";
                        $display_message = __( 'Add Email Template' , 'woocommerce-ac' );
                        if ( 'edittemplate' == $mode ) {
                            $button_mode     = "update";
                            $display_message = __( 'Edit Email Template', 'woocommerce-ac' );
                        }
                        print'<input type="hidden" name="ac_settings_frm" value="'.$button_mode.'">'; ?>
                            <div id="poststuff">
                                <div> <!-- <div class="postbox" > -->
                                    <h3 class="hndle">
                                        <?php echo $display_message; ?>
                                    </h3>
                                    <div>
										<?php
										wc_get_template(
											'html-rules-engine.php',
											array(
												'rules' => isset( $results[0]->rules ) ? json_decode( $results[0]->rules ) : array(),
												'match' => isset( $results[0]->match_rules ) ? $results[0]->match_rules : '',
											),
											'woocommerce-abandon-cart-pro/',
											WCAP_PLUGIN_PATH . '/includes/template/rules/'
										);
										?>
                                        <table class="form-table" id="addedit_template">
                                            <tr>
                                                <th>
                                                    <label for="woocommerce_ac_template_name">
                                                        <?php _e( 'Template Name:', 'woocommerce-ac' );?>
                                                    </label>
                                                </th>
                                                <td>
                                                <?php
                                                    $template_name = "";
                                                    if( 'edittemplate' == $mode ) {
                                                        $template_name = $results[0]->template_name;
                                                    }
                                                    if( 'copytemplate' == $mode ) {
                                                        $template_name = "Copy of ".$results_copy[0]->template_name;
                                                    }
                                                    print'<input type="text" name="woocommerce_ac_template_name" id="woocommerce_ac_template_name" class="regular-text" value="' . $template_name . '">'; ?>
                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Enter a template name for reference' , 'woocommerce' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" />
                                                </td>
                                            </tr>
                                            <tr>
                                                <th>
                                                    <label for="woocommerce_ac_email_frequency">
                                                        <?php _e( 'Send this email:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                    <select name="email_frequency" id="email_frequency">
                                                    <?php
                                                        $frequency_edit="";
                                                        if ( 'edittemplate' == $mode ) {
                                                            $frequency_edit=$results[0]->frequency;
                                                        }
                                                        if ( 'copytemplate' == $mode ) {
                                                            $frequency_edit=$results_copy[0]->frequency;
                                                        }
                                                        for ( $i=1;$i<60;$i++ ) {
                                                            printf( "<option %s value='%s'>%s</option>\n",
                                                                selected( $i, $frequency_edit, false ),
                                                                esc_attr( $i ),
                                                                $i
                                                            );
                                                        }
                                                    ?>
                                                    </select>
                                                    <select name="day_or_hour" id="day_or_hour">
                                                    <?php
                                                        $days_or_hours_edit = "";
                                                        if ( 'edittemplate' == $mode ) {
                                                            $days_or_hours_edit=$results[0]->day_or_hour;
                                                        }
                                                        if ( 'copytemplate' == $mode ) {

                                                            $days_or_hours_edit=$results_copy[0]->day_or_hour;
                                                        }
                                                        $days_or_hours = array(
                                                               'Minutes'    => __( 'Minute(s)', 'woocommerce-ac'),
                                                               'Days'       => __( 'Day(s)', 'woocommerce-ac'),
                                                               'Hours'      => __( 'Hour(s)', 'woocommerce-ac')
                                                            );
                                                        foreach( $days_or_hours as $k => $v ) {
                                                            printf( "<option %s value='%s'>%s</option>\n",
                                                                selected( $k, $days_or_hours_edit, false ),
                                                                esc_attr( $k ),
                                                                $v
                                                            );
                                                        }
                                                    ?>
                                                    </select>
                                                    <span class="description"><?php
                                                        echo __( 'after cart is abandoned.', 'woocommerce-ac' );
                                                    ?>
                                                    </span>
                                                </td>
                                            </tr>

                                            <tr>
                                                <th>
                                                    <label for="woocommerce_ac_email_subject">
                                                        <?php _e( 'Subject:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>

                                                    <?php
                                                    $subject_edit="";

                                                    if ( 'edittemplate' == $mode ) {
                                                        $subject_edit=$results[0]->subject;
                                                    }

                                                    if ( 'copytemplate' == $mode ) {
                                                        $subject_edit=$results_copy[0]->subject;
                                                    }
                                                    print'<input type="text" name="woocommerce_ac_email_subject" id="woocommerce_ac_email_subject" class="regular-text" value="' . $subject_edit . '">'; ?>
                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Enter the subject that should appear in the email sent', 'woocommerce' ); ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" /></p>
                                                   <?php
                                                        printf(
                                                            /* translators: %1$s,%2$s,%3$s and %4$s are replaced  customer firstname, name of first product in cart, literal string and sample name respectively */
                                                            __( 'Add the shortcode %1$s or %2$s to include the Customer First Name and Product name ( %3$s ) to the Subject Line. For e.g. Hi %4$s You left some Protein Bread in your cart', 'woocommerce-ac' ),
                                                            '{{customer.firstname}}',
                                                            '{{product.name}}',
                                                            __( 'first in the cart' ),
                                                            'John!!'
                                                        );
                                                    ?>
                                                </td>
                                            </tr>
                                            <tr>
                                                <th>
                                                    <label for="woocommerce_ac_email_body">
                                                        <?php _e( 'Email Body:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                <?php
                                                    $initial_data = "";
                                                    if ( 'edittemplate' == $mode ) {
                                                        $initial_data = $results[0]->body;
                                                    }
                                                    if ( 'copytemplate' == $mode ) {
                                                        $initial_data = $results_copy[0]->body;
                                                    }
                                                    $initial_data = str_replace ( "My document title", "", $initial_data );

                                                    wp_editor(
                                                        $initial_data,
                                                        'woocommerce_ac_email_body',
                                                        array(
                                                        'media_buttons' => true,
                                                        'textarea_rows' => 15,
                                                        'tabindex' => 4,
                                                        'tinymce' => array(
                                                            'theme_advanced_buttons1' => 'bold,italic,underline,|,bullist,numlist,blockquote,|,link,unlink,|,spellchecker,fullscreen,|,formatselect,styleselect',
                                                         ),
                                                        )
                                                    );
                                                ?>
                                                    <span class="description">
                                                    <?php
                                                        echo __( 'Message to be sent in the reminder email.', 'woocommerce-ac' );
                                                    ?>
                                                        <img width="16" height="16" src="<?php echo plugins_url(); ?>/woocommerce-abandon-cart-pro/assets/images/information.png" onClick="bkap_show_help_tips()"/>
                                                    </span>
                                                    <span id="help_message" style="display:none">
                                                      <?php
                                                        esc_html_e( '1. You can add customer & cart information in the template using this icon'); ?> <img width="20" height="20" src="<?php echo plugins_url(); ?>/woocommerce-abandon-cart-pro/assets/images/ac_editor_icon.png" /> <?php esc_html_e( 'in top left of the editor' ); echo '<br>';
                                                        esc_html_e( '2. You can now customize the product information/cart contents table that is added when using the {{products.cart}} merge field' ); echo '<br>';
                                                        esc_html_e( '3. Add/Remove columns from the default table by selecting the column and clicking on the Remove Column Icon in the editor' ); echo '<br>';
                                                        esc_html_e( '4. Insert/Remove any of the new shortcodes that have been included for the product table' ); echo '<br>';
                                                        esc_html_e( '5. Change the look and feel of the table by modifying the table style properties using the Edit Table Icon in the editor' ); echo '<br>';
                                                        esc_html_e( '6. Change the background color of the table rows by using the Edit Table Row Icon in the editor' ); echo '<br>';
                                                    ?>
                                                    </span>
                                                </td>
                                            </tr>
                                            <script type="text/javascript">
                                                function bkap_show_help_tips() {
                                                    if( jQuery( '#help_message' ) . css( 'display' ) == 'none') {
                                                        document.getElementById( "help_message" ).style.display = "block";
                                                    }
                                                    else {
                                                        document.getElementById( "help_message" ) . style.display = "none";
                                                    }
                                                }
                                            </script>
                                            <tr>
                                                <th>
                                                    <label for="is_wc_template">
                                                        <?php _e( 'Use WooCommerce Template Style:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>

                                                <?php
                                                    $is_wc_template="";
                                                    if ( 'edittemplate' == $mode ) {
                                                        $use_wc_template = $results[0]->is_wc_template;
                                                        $is_wc_template = "";
                                                        if ( $use_wc_template == '1' ) {
                                                            $is_wc_template = "checked";
                                                        }
                                                    }

                                                    if ( $mode == 'copytemplate' ) {
                                                        $use_wc_template = $results_copy[0]->generate_unique_coupon_code;
                                                        $is_wc_template = "";
                                                        if( '1' == $use_wc_template ) {
                                                            $is_wc_template = "checked";
                                                        }
                                                    }
                                                    print'<input type="checkbox" name="is_wc_template" id="is_wc_template" ' . $is_wc_template . '>  </input>'; ?>
                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Use WooCommerce default style template for abandoned cart reminder emails.', 'woocommerce' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" /> 
                                                    <a href= '#' id ='wcap_wc_preview' class= 'wcap_wc_preview button-primary' data-modal-type='wcap_preview_ajax' data-email-type = 'wcap_wc_preview' > Preview WooCommerce Email </a> &nbsp; &nbsp; 
                                                    <a href='#' id='wcap_preview' class = 'wcap_preview button-primary' data-modal-type='wcap_preview_ajax' data-email-type = 'wcap_preview' >Preview Custom Email</a> 
                                                   
                                                </td>
                                            </tr>

                                            <tr>
                                                <th>
                                                    <label for="wcap_wc_email_header">
                                                        <?php _e( 'Email Template Header Text: ', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                <?php

                                                    $wcap_wc_email_header = "";
                                                    if ( 'edittemplate' == $mode ) {
                                                        $wcap_wc_email_header = $results[0]->wc_email_header;
                                                    }
                                                    if ( 'copytemplate' == $mode ) {
                                                        $wcap_wc_email_header = $results_copy[0]->wc_email_header;
                                                    }
                                                    if ( "" == $wcap_wc_email_header ) {
                                                        $wcap_wc_email_header = __( 'Abandoned cart reminder', 'woocommerce-ac' );
                                                    }
                                                    print'<input type="text" name="wcap_wc_email_header" id="wcap_wc_email_header" class="regular-text" value="' . $wcap_wc_email_header . '">'; ?>
                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Enter the header which will appear in the abandoned WooCommerce email sent. This is only applicable when only used when "Use WooCommerce Template Style:" is checked.', 'woocommerce-ac' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" /></p>
                                                </td>
                                            </tr>

                                            <tr>
                                                <th>
                                                    <label for="unique_coupon">                                                        
                                                        <?php _e( 'Generate unique coupon codes:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                <?php
                                                    $is_unique_coupon = "";
                                                    if ( 'edittemplate' == $mode ) {
                                                        $unique_coupon = $results[0]->generate_unique_coupon_code;
                                                        $is_unique_coupon = "";
                                                        if ( '1' == $unique_coupon ) {
                                                            $is_unique_coupon = "checked";
                                                        }
                                                    }
                                                    if ( 'copytemplate' == $mode ) {
                                                        $unique_coupon = $results_copy[0]->generate_unique_coupon_code;
                                                        $is_unique_coupon = "";
                                                        if( '1' == $unique_coupon ) {
                                                            $is_unique_coupon = "checked";
                                                        }
                                                    }
                                                    print'<input type="checkbox" name="unique_coupon" id="unique_coupon" ' . $is_unique_coupon . '>  </input>'; ?>
                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Replace this coupon with unique coupon codes for each customer', 'woocommerce' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" /></p>
                                                </td>
                                            </tr>

                                            <!-- Below is the Coupon Code Options chnages -->

                                            <?php 
                                            $show_row = "display:none;";
                                            if ( "" !== $is_unique_coupon ) {
                                                $show_row = "";
                                            }
                                            ?>

                                            <tr class="wcap_discount_options_rows" style="<?php echo $show_row; ?>">
                                                <th>
                                                    <label class="wcap_discount_options" for="wcap_discount_type">
                                                        <?php _e( 'Discount Type:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                    <?php

                                                    $discount_type  = isset( $results[0]->discount_type ) ? $results[0]->discount_type : '';
                                                    $precent        = '';
                                                    $fixed          = '';

                                                    if ( 'copytemplate' == $mode ) {
                                                        $discount_type = $results_copy[0]->discount_type;
                                                    }

                                                    if ( $discount_type == 'percent' ) {
                                                        $precent = 'selected';
                                                    } else if ( $discount_type == 'fixed' ) {
                                                        $fixed = 'selected';
                                                    }
                                                    ?>
                                                    <select id="wcap_discount_type" name="wcap_discount_type">
                                                        <option value="percent" <?php echo $precent; ?>><?php _e( 'Percentage discount', 'woocommerce-ac' );?></option>
                                                        <option value="fixed" <?php echo $fixed; ?>><?php _e( 'Fixed cart discount', 'woocommerce-ac' );?></option>
                                                    </select>                                                    
                                                </td>
                                            </tr>

                                            <tr class="wcap_discount_options_rows" style="<?php echo $show_row; ?>">
                                                <th>
                                                    <label class="wcap_discount_options" for="wcap_coupon_amount">
                                                        <?php _e( 'Coupon amount:', 'woocommerce-ac' );?>
                                                    </label>
                                                </th>
                                                <td>
                                                <?php
                                                    $discount = 0;
                                                    if ( 'edittemplate' == $mode ) {
                                                        $discount = $results[0]->discount;
                                                    }

                                                    if ( 'copytemplate' == $mode ) {
                                                        $discount = $results_copy[0]->discount;
                                                    }

                                                    print'<input type="text" style="width:8%;" name="wcap_coupon_amount" id="wcap_coupon_amount" class="short" value="' . $discount . '">'; ?>
                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Value of the coupon.' , 'woocommerce' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" />
                                                </td>
                                            </tr>

                                            <tr class="wcap_discount_options_rows" style="<?php echo $show_row; ?>">
                                                <th>
                                                    <label class="wcap_discount_options" for="wcap_allow_free_shipping">
                                                        <?php _e( 'Allow free shipping:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>

                                                <?php
                                                    $discount_shipping_check    = "";
                                                    $discount_shipping          = '';
                                                    if ( 'edittemplate' == $mode ) {
                                                        $discount_shipping = $results[0]->discount_shipping;
                                                    }

                                                    if ( 'copytemplate' == $mode ) {
                                                        $discount_shipping = $results_copy[0]->discount_shipping;
                                                    }

                                                    if ( "yes" === $discount_shipping ) {
                                                        $discount_shipping_check = "checked";
                                                    }
                                                    
                                                    print'<input type="checkbox" name="wcap_allow_free_shipping" id="wcap_allow_free_shipping" ' . $discount_shipping_check . '>  </input>'; ?>
                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Check this box if the coupon grants free shipping. A free shipping method must be enabled in your shipping zone and be set to require "a valid free shipping coupon" (see the "Free Shipping Requires" setting).', 'woocommerce-ac' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" />
                                                   
                                                </td>
                                            </tr>

                                            <tr class="wcap_discount_options_rows" style="<?php echo $show_row; ?>">
                                                <th>
                                                    <label class="wcap_discount_options" for="wcac_coupon_expiry">
                                                        <?php _e( 'Coupon validity:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                    <?php
                                                    $wcac_coupon_expiry     = "7-days";
                                                    $expiry_days_or_hours   = array( 'hours' => 'Hour(s)', 'days' => 'Day(s)' );
                                                    if ( 'edittemplate' == $mode ) {
                                                        $wcac_coupon_expiry = $results[0]->discount_expiry;
                                                    }
                                                    if ( 'copytemplate' == $mode ) {
                                                        $wcac_coupon_expiry = $results_copy[0]->discount_expiry;
                                                    }

                                                    $wcac_coupon_expiry_explode = explode( "-", $wcac_coupon_expiry );
                                                    $expiry_number              = isset( $wcac_coupon_expiry_explode[0] ) ? $wcac_coupon_expiry_explode[0] : 0;
                                                    $expiry_freq                = isset( $wcac_coupon_expiry_explode[1] ) ? $wcac_coupon_expiry_explode[1] : 'hours';

                                                    print'<input type="text" style="width:8%;" name="wcac_coupon_expiry" id="wcac_coupon_expiry" value="' . $expiry_number . '">  </input>'; ?>

                                                    <select name="expiry_day_or_hour" id="expiry_day_or_hour">
                                                    <?php
                                                        foreach( $expiry_days_or_hours as $k => $v ) {
                                                            printf( "<option %s value='%s'>%s</option>\n",
                                                                selected( $k, $expiry_freq, false ),
                                                                esc_attr( $k ),
                                                                $v
                                                            );
                                                        }
                                                    ?>
                                                    </select>

                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'The coupon code which will be sent in the reminder emails will be expired based the validity set here. E.g if the coupon code sent in the reminder email should be expired after 7 days then set 7 Day(s) for this option.', 'woocommerce-ac' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" />
                                                </td>
                                            </tr>

											<tr class='wcap_discount_options_rows' style='<?php echo $show_row; ?>'>
												<th>
                                                    <label class='wcap_discount_options' for='individual_use'>                                                        
                                                        <?php _e( 'Individual use only:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                <?php
                                                    $is_individual_use = 'checked';
                                                    if ( 'edittemplate' == $mode ) {
                                                        $individual_use = $results[0]->individual_use;
                                                        if ( '1' != $individual_use ) {
                                                            $is_individual_use = '';
                                                        }
                                                    }
                                                    if ( 'copytemplate' == $mode ) {
                                                        $individual_use = $results_copy[0]->individual_use;
                                                        if( '1' != $individual_use ) {
                                                            $is_individual_use = '';
                                                        }
                                                    }
                                                    print'<input type="checkbox" name="individual_use" id="individual_use" ' . $is_individual_use . '>  </input>'; ?>
                                                    <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Check this box if the coupon cannot be used in conjunction with other coupons.', 'woocommerce' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" /></p>
                                                </td>
											</tr>

                                            <!-- The Coupon Code Options chnages ends here -->
                                            <tr><th></th><td><b><?php _e( 'OR', 'woocommerce-ac'); ?></b></td></tr>
                                            <tr>
                                                <th>
                                                    <label for="woocommerce_ac_coupon_auto_complete">
                                                        <?php _e( 'Enter a coupon code to add into email:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                    <!-- code started for woocommerce auto-complete coupons field emoved from class : woocommerce_options_panelfor WC 2.5 -->
                                                    <div id="coupon_options" class="panel">
                                                        <div class="options_group">
                                                            <p class="form-field" style="padding-left:0px !important;">

                                                            <?php

                                                                $json_ids       = array();
                                                                $coupon_ids     = array();
                                                                $coupon_code_id = '';
                                                                if ( 'edittemplate' == $mode ) {
                                                                    $coupon_code_id = $results[0]->coupon_code;
                                                                }
                                                                if ( 'copytemplate' == $mode ) {
                                                                    $coupon_code_id = $results_copy[0]->coupon_code;
                                                                }
                                                                if ( $coupon_code_id > 0 ) {
                                                                    if ( 'edittemplate' == $mode ) {
                                                                        $coupon_ids  = explode ( ",", $results[0]->coupon_code );
                                                                    }
                                                                    if ( 'copytemplate' == $mode ) {
                                                                        $coupon_ids  = explode ( ",", $results_copy[0]->coupon_code );
                                                                    }
                                                                     foreach ( $coupon_ids as $product_id ) {
                                                                        if ( $product_id > 0 ) {
                                                                            $product = get_the_title( $product_id );
                                                                            $json_ids[ $product_id ] = $product ;
                                                                        }
                                                                    }

                                                                }
                                                                if( version_compare( $woocommerce->version, '3.0.0', ">=" ) ) {
                                                                    ?>
                                                                    <select id="coupon_ids" name="coupon_ids[]" class="wc-product-search" multiple="multiple" style="width: 50%;" data-placeholder="<?php esc_attr_e( 'Search for a Coupon&hellip;', 'woocommerce' ); ?>" data-action="wcap_json_find_coupons">
                                                                        <?php
                                                                        foreach ( $coupon_ids as $product_id ) {
                                                                            if ( $product_id > 0  ) {
                                                                                $product = get_the_title( $product_id );
                                                                                echo '<option value="' . esc_attr( $product_id ) . '"' . selected( true, true, false ) . '>' . wp_kses_post( $product ) . '</option>';
                                                                            }
                                                                        }
                                                                        ?>
                                                                    </select>
                                                                    <?php
                                                                } else {
                                                                    ?>
                                                                    <input type="hidden" id="coupon_ids" name="coupon_ids[]" class="wc-product-search" style="width: 30%;" data-placeholder="<?php esc_attr_e( 'Search for a Coupon&hellip;', 'woocommerce' ); ?>" data-multiple="true" data-action="wcap_json_find_coupons"
                                                                       data-selected=" <?php echo esc_attr( json_encode( $json_ids ) ); ?> " value="<?php echo implode( ',', array_keys( $json_ids ) ); ?>"
                                                                    />
                                                                    <?php
                                                                }
                                                            ?>
                                                                <img class="help_tip" width="16" height="16" data-tip='<?php _e( 'Search & select one coupon code that customers should use to get a discount.  Generated coupon code which will be sent in email reminder will have the settings of coupon selected in this option.', 'woocommerce-ac' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" />
                                                            </p>
                                                        </div>
                                                    </div>
                                                    <!-- code ended for woocommerce auto-complete coupons field -->
                                                </td>
                                            </tr> <!-- add new check box -->

                                            <tr>
                                                <th>
                                                    <label for="woocommerce_ac_email_preview">
                                                        <?php _e( 'Send a test email to:', 'woocommerce-ac' ); ?>
                                                    </label>
                                                </th>
                                                <td>
                                                    <input type="text" id="send_test_email" name="send_test_email" class="regular-text" >
                                                    <input type="button" value="<?php _e( 'Send a test email','woocommerce-ac' ); ?>" id="preview_email" class="button" onclick="javascript:void(0);">
                                                    <img   class="help_tip" width="16" height="16" data-tip='<?php _e( 'Enter the email id to which the test email needs to be sent.', 'woocommerce' ) ?>' src="<?php echo plugins_url(); ?>/woocommerce/assets/images/help.png" />
                                                    <br>
                                                    <img class="ajax_img" src="<?php echo WCAP_PLUGIN_URL . '/assets/images/ajax-loader.gif';?>" style="display:none;" />
                                                    <div   id="preview_email_sent_msg" style="display:none;"></div>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        <p class="submit">
                        <?php
                            $button_value = __( 'Save Changes', 'woocommerce-ac' );
                            if ( 'edittemplate' == $mode ) {
                                $button_value = __( 'Update Changes', 'woocommerce-ac' );
                            }
                        ?>
                            <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e( $button_value, 'woocommerce-ac' ); ?>"  />
                            <input id="cancel-save" type="button" name="cancel" class="button-primary" value="<?php esc_attr_e( 'Cancel', 'woocommerce-ac' ); ?>"  data-redirect="<?php echo admin_url('admin.php?page=woocommerce_ac_page&action=cart_recovery');?>" />
                       
                        </p>
                    </form>
                </div>
                <script type="text/javascript">
                    jQuery(document).ready( function(){
                        jQuery('#cancel-save').on('click',function(){
                            var r = confirm("<?php echo __( 'Are you sure you want to cancel the changes?', 'woocommerce-ac' ); ?>");                            
                            if (r == true) {
                                window.location = jQuery(this).attr('data-redirect')
                            }
                        })
                    })
                </script>
            <?php

            wc_get_template( 
                'preview_modal.php', 
                '', 
                'woocommerce-abandon-cart-pro/',
                WCAP_PLUGIN_PATH . '/includes/template/preview_modal/' );
        }
    }
}
